.\"
.\" $Id: ximrc.man,v 1.1.1.1 2000/01/16 05:07:58 ura Exp $
.\"

.\" FreeWnn is a network-extensible Kana-to-Kanji conversion system.
.\" This file is part of FreeWnn.
.\" 
.\" Copyright OMRON Corporation. 1987, 1988, 1989, 1990, 1991, 1992, 1999
.\" Copyright 1991 by Massachusetts Institute of Technology
.\"
.\" Author: OMRON SOFTWARE Co., Ltd. <freewnn@rd.kyoto.omronsoft.co.jp>
.\"
.\" This program is free software; you can redistribute it and/or modify
.\" it under the terms of the GNU General Public License as published by
.\" the Free Software Foundation; either version 2, or (at your option)
.\" any later version.
.\"
.\" This program is distributed in the hope that it will be useful,
.\" but WITHOUT ANY WARRANTY; without even the implied warranty of
.\" MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
.\" GNU General Public License for more details.
.\"
.\" You should have received a copy of the GNU General Public License
.\" along with GNU Emacs; see the file COPYING.  If not, write to the
.\" Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.\"
.\" Commentary:
.\"
.\" Change log:
.\"
.\" Last modified date: 8,Feb.1999
.\"

.TH XIMRC 4 "Release 5" "X Version 11"
.SH NAME
ximrc \- Environment setting file of Input Manager of the X Window
System Version 11 (xwnmo(1X))
.SH SYNOPSIS
.B /usr/local/lib/wnn/ximrc (Default)
.SH DESCRIPTION
The \fIximrc\fP file sets up the environment for the \fIxwnmo\fP.
Individual settings can be specified for each user.
Duplicate entries will be overwritten.
Lines that start with a semicolon (;) are comments.
.PP
\fIXwnmo\fP will search this file as follows:
.TP 8
1. Resource "ximrcName"
.br
2. $HOME/.ximrc
.br
3. /usr/local/lib/wnn/ximrc (Default)
.PP
The following settings are specified in this file.  Any setting which is not 
specified will use the default value.  
.TP 8
.B setuumrc <\fIlanguage_name\fP> <\fIuumrc_file_name\fP>
Specifies the \fIuumrc\fP file that \fIxwnmo\fP uses for uumrc each language.
The default is "@LIBDIR/@LANG/uumrc".
.TP 8
.B preloadrkfile <\fIlanguage_name\fP>
Specifies the language that automaton conversion pre-load.
In default, the language of Root-mode is loaded.
.TP 8
.B setbackspacechar <\fIbackspace_char\fP>
Specifies the character for back-space.
If it isn't set, \fIXwnmo\fP will get ERASE code of /dev/console.
If \fIxwnmo\fP couldn't open /dev/console, the default is 0xff.
.SH EXAMPLE
setuumrc        ja_JP           /usr/demos/ja_JP/uumrc
.br
setuumrc        zh_CN           /usr/demos/zh_CN/uumrc
.br
preloadrkfile   ja_JP
.br
preloadrkfile   zh_CN
.br
setbackspacechar ^H
.SH "SEE ALSO"
xwnmo(1X), ximconf(4X)
.SH COPYRIGHT
Copyright 1991 by OMRON Corporation
.br
Copyright 1991 by Massachusetts Institute of Technology
.SH AUTHOR
Seiji Kuwari (OMRON Corporation)
