.\"
.\"   $Id: cwnnstat.man,v 1.3 2001/06/14 18:08:35 ura Exp $
.\"
.\"
.\" FreeWnn is a network-extensible Kana-to-Kanji conversion system.
.\" This file is part of FreeWnn.
.\" 
.\" Copyright Kyoto University Research Institute for Mathematical Sciences
.\"                 1987, 1988, 1989, 1990, 1991, 1992
.\" Copyright OMRON Corporation. 1987, 1988, 1989, 1990, 1991, 1992, 1999
.\" Copyright ASTEC, Inc. 1987, 1988, 1989, 1990, 1991, 1992
.\" Copyright FreeWnn Project 1999, 2000
.\" 
.\" Maintainer:  FreeWnn Project   <freewnn@tomo.gr.jp>
.\" 
.\" This program is free software; you can redistribute it and/or modify
.\" it under the terms of the GNU General Public License as published by
.\" the Free Software Foundation; either version 2 of the License, or
.\" (at your option) any later version.
.\" 
.\" This program is distributed in the hope that it will be useful,
.\" but WITHOUT ANY WARRANTY; without even the implied warranty of
.\" MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
.\" GNU General Public License for more details.
.\" 
.\" You should have received a copy of the GNU General Public License
.\" along with this program; if not, write to the Free Software
.\" Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
.\"
.TH CWNNSTAT \  "13 May 1992"
.SH NAME
cwnnstat \- To show the current status of cserver.
.SH SYNOPSIS
cwnnstat  [-w] [-e] [-E] [-f] [-F] [-d] [-D] 
          [-L 
.I lang
] [
.I hostname
]
.SH DEFAULT PATH
/usr/local/bin/cWnn4/cwnnstat
.ad
.SH DESCRIPTION
To request for the current execution status of the cserver 
for the current host.

If 
.I hostname 
is specified, the status of the that specified
host will be given.
.SH OPTIONS
.IP -w
To list the username, hostname, socket number and the environment number.
.IP -e
To list the environment number, environment name and reference count.
.IP -E
To list the environment number, environment name, reference count, 
grammar file number, number of dictionary used, (list of dictionary numbers)
and the numbers of the files used in the current environment.
.IP -f
To list the file ID of each cWnn file in the cserver, the file type, 
the location of file, reference count and the filename.
.IP -F
Same as -f option
.IP -d
To list the dictionary number of dictionaries managed by the host, the 
dictionary type, dictionary file number, dictionary filename, usage 
frequency filename and usage frequency file number.
.IP -D 
To list the dictionary number, type, conversion method, number of entries, 
static/dynamic, current usage status, priority, alias, filename, 
[(alias:usage frequency filename)], [password (frequency password)] of 
the dictionaries.
.IP -L
To specify the language name which is referred during selection of cserver.
If no 
.I lang 
is specified, the one specified by the environment variable 
LANG will be used.  The default is "zh_CN".
.SH NOTE
.IP 1.
The command options inside [ ] shown in the Command Format indicates that 
they are optional.  If they are not required, "cwnnstat" alone is 
sufficient to obtain the status of cserver.
.IP 2.
Dictionary number is different from file number. 
.sp 0
- File number refers to the standardized number among 
  all cWnn files.
.sp 0
- Dictionary number refers to the logical dictionary 
  number in the server.
.IP 3.
One dictionary file may consist of different usage frequency files, and 
each will form an individual dictionary.
.IP 4.
One dictionary file with  different conversion methods (forward/reverse) 
will form different dictionaries.
